import 'package:json_annotation/json_annotation.dart';

import 'connection_type.dart';
import 'region.dart';

part 'connection.g.dart';

@JsonSerializable(createToJson: false)
class Connection {
  final String id;
  final String name;
  @JsonKey(name: "von")
  final String origin;
  @JsonKey(name: "nach")
  final String destination;
  @JsonKey(name: "kbnr")
  final String courseBookNumber;
  @JsonKey(name: "verlauf")
  final List<String> stops;
  @JsonKey(name: "via")
  final String via;
  final DateTime timestamp;
  @JsonKey(name: "verfall")
  final DateTime expiryDate;
  @JsonKey(name: "verbindung")
  final ConnectionType type;
  @JsonKey(name: "land")
  final Region region;
  final String url;
  @JsonKey(name: "ics")
  final String icsUrl;
  @JsonKey(name: "doc")
  final String documentUrl;

  const Connection({
    this.id,
    this.name,
    this.origin,
    this.destination,
    this.courseBookNumber,
    this.stops,
    this.via,
    this.timestamp,
    this.expiryDate,
    this.type,
    this.region,
    this.url,
    this.icsUrl,
    this.documentUrl,
  });

  factory Connection.fromJson(Map<String, dynamic> json) =>
      _$ConnectionFromJson(json);
}
